"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var date_fns_1 = require("date-fns");
var cli_progress_1 = require("cli-progress");
exports.parseDate = function (text, formats) {
    var fallBack = new Date();
    for (var _i = 0, formats_1 = formats; _i < formats_1.length; _i++) {
        var format = formats_1[_i];
        var date = date_fns_1.parse(text, format, fallBack);
        if (date_fns_1.isValid(date) && date !== fallBack) {
            return date;
        }
    }
    return null;
};
function executeTasks(tasks) {
    return __awaiter(this, void 0, void 0, function () {
        var progressBar, retVal;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    progressBar = new cli_progress_1.SingleBar({
                        format: "[{bar}] {percentage}% || {value}/{total}",
                        hideCursor: true
                    }, cli_progress_1.Presets.legacy);
                    progressBar.start(tasks.length, 0);
                    return [4 /*yield*/, Promise.all(tasks.map(function (task) { return __awaiter(_this, void 0, void 0, function () {
                            var val;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, task()];
                                    case 1:
                                        val = _a.sent();
                                        progressBar.increment(1);
                                        return [2 /*return*/, val];
                                }
                            });
                        }); }))];
                case 1:
                    retVal = _a.sent();
                    progressBar.stop();
                    return [2 /*return*/, retVal];
            }
        });
    });
}
exports.executeTasks = executeTasks;
